"""
/**********************************************************

    Organization    :AsymptopiaSoftware | Software@theLimit

    Website         :www.asymptopia.org

    Author          :Charles B. Cosse

    Email           :ccosse@gmail.com

    Copyright       :(C) 2006-2008 Asymptopia Software

    License         :GPL2

***********************************************************/
"""
import os,sys,string,time,types
from random import *
from wxPython.wx import *
import  wx.lib.scrolledpanel as scrolled

from pygame import *

from cfgctrlobj import *
from dict_formatter import *

DEBUG=0

class CfgCtrl(wxPanel):
	
	def __init__(self,parent,nb,tab_name):
		
		self.parent=parent
		self.nb=nb
		self.tab_name=tab_name
		self.env=self.parent.env
		self.global_config=self.parent.global_config
		
		self.cfg=None
		self.sizer=None
		self.cp=None
		self.cpbox=None
		self.cfgctrlobjs=[]
		
		self.ID=wxNewId()
		wxPanel.__init__(self,nb,self.ID,wxDefaultPosition,wxDefaultSize,style=wxFULL_REPAINT_ON_RESIZE)#wxVSCROLL|
		
	def setup(self):
		button_height=30
		if self.env.OS=='win':button_height=20
		button_size=wxSize(100,button_height)
		self.toolbar=wxToolBar(self,wxNewId(),style=wxTB_HORIZONTAL)# | wxNO_BORDER | wxTB_FLAT | wxTB_TEXT
		#self.toolbar.SetBackgroundColour(self.global_config['COLOR_BG_CFG']['value'])
		
		#...........................................................
		#SAVE BUTTON
		xid=wxNewId()
		saveB=wxButton(self.toolbar,xid,"Save",size=button_size,pos=wxPoint(0,0))
		self.toolbar.AddControl(saveB)
		saveB.SetToolTip(wxToolTip('Save these configuration options'))
		EVT_BUTTON(self.toolbar,xid,self.saveCB)

		#...........................................................
		#LOGOUT BUTTON
		xid=wxNewId()
		logoutB=wxButton(self.toolbar,xid,"Hide",size=button_size,pos=wxPoint(100,0))
		logoutB.SetToolTip(wxToolTip('Hide the Administrator Control Panel.'))
		self.toolbar.AddControl(logoutB)
		EVT_BUTTON(self.toolbar,xid,self.logoutCB)

		self.cp=scrolled.ScrolledPanel(self,wxNewId(),wxDefaultPosition,style=wxFULL_REPAINT_ON_RESIZE|wxALWAYS_SHOW_SB|wxVSCROLL)
		self.cp.SetupScrolling()

		self.cp.SetBackgroundColour(self.global_config['COLOR_BG_ADMIN']['value'])
		
		self.sizer=wxBoxSizer(wxVERTICAL)
		self.sizer.Add(self.toolbar,0,wxEXPAND)
		self.sizer.Add(self.cp,1,wxGROW,1)
		self.SetSizer(self.sizer)
		self.SetAutoLayout(True)
		self.Layout()
		
		if self.tab_name=='Accounts':self.reload('new')
		elif self.tab_name=='Globals':self.reload('globals')
		elif self.tab_name=='StudentData':self.reload('default')
		
	def deleteCB(self,e):
	
		if self.cfg['CFGNAME']=='new':return
		if self.cfg['CFGNAME']=='admin':return
		if self.cfg['CFGNAME']=='guest':return
		if self.cfg['CFGNAME']=='globals':return
		if self.cfg['CFGNAME']=='default':return
		
		fname=os.path.join(self.env.configdir,self.tab_name,self.cfg['CFGNAME'])
		try:os.removedirs(fname)
		except:pass#print 'unable to recursively delete 1x',fname
		
		cmd=None
		if self.env.OS=='lin' or self.env.OS=='mac':cmd="rm -rf %s"%(fname)
		else:cmd="del %s"%(fname)
		if DEBUG:print cmd
		try:os.system(cmd)
		except:pass#print 'unable to recursively delete 2x',fname
		
		self.reload('new')


	def saveCB(self,evt):
		
		#print 'saveCB'
		#check for USERNAME='new'; here/this is the only filter.
		for obj in self.cfgctrlobjs:
			if obj.key=='USERNAME':
				if str(obj.widget.GetValue())=='new':return
			elif obj.key=='PROFILE_NAME':
				if str(obj.widget.GetValue())=='default':return
		
		#update fields w/assoc ctrl widgets
		for obj in self.cfgctrlobjs:
			obj.update()#widget.value -> obj.val['value']
			key=obj.key
			val=obj.val
			self.cfg[key]=val
			if key=='USERNAME':self.cfg['CFGNAME']=val['value']
			elif key=='PROFILE_NAME':self.cfg['PROFILE_NAME']=val['value']
		
		oufdir=os.path.join(self.env.configdir,self.tab_name,self.cfg['CFGNAME'])
		if not os.path.exists(oufdir):
			print 'ALERT! making a new dir!!'
			os.mkdir(oufdir)
		oufname=os.path.join(oufdir,'config')
		ouf=open(oufname,'w')
		
		rval=format_dict(self.cfg,0)
		
		if DEBUG:print rval
		ouf.write(rval)
		ouf.close()
		
		
		try:
			self.reload(self.cfg['CFGNAME'])
		except Exception,e:
			if DEBUG:print e
		
		if DEBUG:print 'saveCB done.'
		#
	
	def reload_configs(self):
		self.parent.reload_configs()
		self.global_config=self.parent.global_config
		
			
	def load_selected(self,evt):
		
		#load the selected config
		target='globals'#self.cb.GetValue()
		sitepkgdir=self.env.sitepkgdir
		configdir=self.env.configdir
		self.cfg=self.load_config(os.path.join(self.tab_name,target),'config')
		
		
		#clear/delete? self.ControlPanel
		if self.cp!=None:
			self.cp.DestroyChildren()
			self.sizer.Remove(self.cp)
			del self.cp
			self.cp=None
		
		#re-create ControlPanel:
		self.cfgctrlobjs=[]
		W=self.global_config['WIN_W']['value']-self.global_config['SPLITTER_OFFSET']['value']-100
		H=self.global_config['WIN_H']['value']
		cpID=wxNewId()
		
#		self.cp=wxScrolledWindow(self,cpID,wxDefaultPosition,size=wxSize(W,H),style=wxFULL_REPAINT_ON_RESIZE|wxALWAYS_SHOW_SB|wxVSCROLL)
		self.cp=scrolled.ScrolledPanel(self,wxNewId(),wxDefaultPosition,style=wxFULL_REPAINT_ON_RESIZE|wxALWAYS_SHOW_SB|wxVSCROLL)
		#print dir(self.cp)
		
		self.reload_configs()
		self.cp.SetBackgroundColour(self.global_config['COLOR_BG_ADMIN']['value'])
		self.cp.SetForegroundColour(self.global_config['COLOR_FG_ADMIN']['value'])
		cpsizer=wxBoxSizer(wxVERTICAL)
		self.sizer.Add(self.cp,1,wxEXPAND,1)
		#staticbox widgets into a vertical box sizer
		keys=self.cfg.keys()
		keys.sort()
		for idx in range(len(keys)):
			item=keys[idx]
			if type(self.cfg[item])!=types.DictType:continue
			if not self.cfg[item].has_key('showme'):continue
			if not self.cfg[item]['showme']:continue
			cpobj=CfgCtrlObj(self.cp,item,self.cfg[item],self.global_config,self.env)
			cpsizer.Add(cpobj.sizer,0,wxGROW,1)
			self.cfgctrlobjs.append(cpobj)#need this still?
		
		self.cp.SetSizer(cpsizer)
		self.cp.SetAutoLayout(True)
		self.Layout()
		self.cp.Layout()
		self.cp.Refresh()
		
		self.cp.SetupScrolling()
		self.cp.SetScrollRate(10,10)

		
	def scrollCB(self,evt):
		if DEBUG:print 'scrollCB'
		
	def load_config(self,intermediate_path,fname):
		
		sitepkgdir	=self.env.sitepkgdir
		configdir	=self.env.configdir
		if DEBUG:print configdir,intermediate_path,fname
		infname=os.path.join(configdir,intermediate_path,fname)
		inf=open(str(infname))
		content=inf.read()
		
		#NEED:re-format tripple-quoted multiline strings
		content=string.strip(content)
		if DEBUG:print content
		
		config=eval(content)
		inf.close()
		return config

	def reload(self,name):
		installed=self.get_installed()
		#for idx in range(len(installed)):
		#	self.cb.Append(installed[idx])
		self.load_selected(None)

	def get_installed(self):
		fnames=os.listdir(os.path.join(self.env.configdir,self.tab_name))
		rnames=[]
		for f in fnames:
			if f=='__init__.py':continue
			rnames.append(f)
		return rnames

	def logoutCB(self,e):
		#type(self.parent)=wxDialog
		self.parent.EndModal(0)
		
