"""
/**********************************************************

    Organization    :AsymptopiaSoftware | Software@theLimit

    Website         :www.asymptopia.org

    Author          :Charles B. Cosse

    Email           :ccosse@gmail.com

    Copyright       :(C) 2006-2008 Asymptopia Software

    License         :GPL2

***********************************************************/
"""
import os,sys,string,time,types
from random import *
from wxPython.wx import *
import  wx.lib.imagebrowser as ib

DEBUG=0

class CfgCtrlObj:
	
	def __init__(self,parent,key,val,global_config,env):
		if DEBUG:print key,val
		self.parent=parent
		self.env=env
		self.key=key
		self.val=val
		self.global_config=global_config
		self.env=env
		
		WIDGET_W=global_config['CONFIG_WIDGET_W']['value']
		WIDGET_H=global_config['CONFIG_WIDGET_H']['value']
		self.wsize=wxSize(WIDGET_W,WIDGET_H)
		
		self.sbox=wxStaticBox(self.parent,-1,key,style=wxBORDER_STATIC)
		self.sbox.SetWindowStyle(wxBORDER_NONE)
		
		self.sizer=wxStaticBoxSizer(self.sbox,wxHORIZONTAL)
		self.widget=None
		self.label=None
		self.defaultB=None
		self.showColourDialogB=None
		self.defaultBID=wxNewId()
		self.set=0
		self.bmp=None
		
		#every CfgCtrlObj has a defaultB:
		self.defaultB=wxButton(self.parent,self.defaultBID,"Default",size=self.wsize)
		
		if self.val['wtype']=='wxComboBox':
			cbID=wxNewId()
			self.widget=wxComboBox(self.parent,cbID,size=self.wsize,choices=os.listdir(os.path.join(self.env.sitepkgdir,global_config['APPNAME'],'Actors')))
			self.widget.SetValue(self.val['value'])
			self.sizer.Add(self.widget)
			EVT_COMBOBOX(self.parent,cbID,self.comboCB)
			
			fname=os.path.abspath(os.path.join(self.env.sitepkgdir,global_config['APPNAME'],'Actors',self.val['value'],'icon.gif'))
			gif=wxImage(fname,wxBITMAP_TYPE_GIF).ConvertToBitmap()
			self.bmp=wxStaticBitmap(self.parent,-1,gif,size=wxSize(WIDGET_W,WIDGET_W))
			self.sizer.Add(self.bmp)
			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)

		elif self.val['wtype']=='wxTextCtrl':
			self.widget=wxTextCtrl(self.parent,wxNewId(),style=self.val['style'],size=self.wsize)
			self.widget.SetValue(self.val['value'])
			self.widget.SetLabel(self.val['descr'])
			self.sizer.Add(self.widget)
			
			label_str=''
			self.label=wxStaticText(self.parent,wxNewId(),label_str,size=self.wsize)
			self.sizer.Add(self.label)

			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)
			
		elif self.val['wtype']=='ImageDialog':
			ImgBrowserID=wxNewId()
			self.widget=ib.ImageDialog(
				self.parent,
				self.val['path'],
			)
			
			ibID=wxNewId()
			self.ibB=wxButton(self.parent,ibID,"ImageDialog",size=self.wsize)
			self.sizer.Add(self.ibB)
			EVT_BUTTON(self.ibB,ibID,self.imagedialogCB)
			
			label_str=''
			self.label=wxStaticText(self.parent,wxNewId(),label_str,size=self.wsize)
			self.label.SetLabel(self.val['value'])
			self.sizer.Add(self.label)

			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)
		
		elif self.val['wtype']=='wxFileDialog':
			
			FileDialogID=wxNewId()
			self.widget=wxFileDialog(
				self.parent,
				message="Choose file",
				defaultDir=self.val['path'],
			)
			
			fdID=wxNewId()
			self.fdB=wxButton(self.parent,fdID,"ShowDialog",size=self.wsize)
			self.sizer.Add(self.fdB)
			EVT_BUTTON(self.fdB,fdID,self.filedialogCB)
			
			label_str=''
			self.label=wxStaticText(self.parent,wxNewId(),label_str,size=self.wsize)
			self.label.SetLabel(self.val['value'])
			self.sizer.Add(self.label)

			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)

			
			
		elif self.val['wtype']=='wxCheckBox':
			CheckBoxID=wxNewId()
			self.widget=wxCheckBox(self.parent,CheckBoxID,"",size=self.wsize)
			self.widget.SetValue(int(self.val['value']))
			self.sizer.Add(self.widget)
			EVT_CHECKBOX(self.widget,CheckBoxID,self.checkboxCB)
		
			label_str=''
			self.label=wxStaticText(self.parent,wxNewId(),label_str,size=self.wsize)
			self.label.SetLabel(`self.val['value']`)
			self.sizer.Add(self.label)

			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)

			self.checkboxCB(None)#to set the label after label exists
			
		elif self.val['wtype']=='wxSpinCtrl':
			SpinCtrlID=wxNewId()
			self.widget=wxSpinCtrl(self.parent,SpinCtrlID,size=self.wsize)
			self.widget.SetRange(self.val['min'],self.val['max'])
			self.widget.SetValue(int(self.val['value']))
			self.sizer.Add(self.widget)
			EVT_SPINCTRL(self.widget,SpinCtrlID,self.spinctrlCB)
			
			label_str=''
			self.label=wxStaticText(self.parent,wxNewId(),label_str,size=self.wsize)
			self.label.SetLabel(`self.val['value']`)
			self.sizer.Add(self.label)

			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)
			
			
		elif self.val['wtype']=='wxColourDialog':
			
			self.widget=wxColourDialog(self.parent)
			self.widget.GetColourData().SetChooseFull(True)
			self.widget.GetColourData().SetColour(wxColour(self.val['value'][0],self.val['value'][1],self.val['value'][2]))
			
			showColourDialogBID=wxNewId()
			self.showColourDialogB=wxButton(self.parent,showColourDialogBID,"ShowDialog",size=self.wsize)
			self.showColourDialogB.SetBackgroundColour(self.widget.GetColourData().GetColour().Get())
			self.sizer.Add(self.showColourDialogB)
			EVT_BUTTON(self.showColourDialogB,showColourDialogBID,self.showColourDialogCB)
			
			label_str=''
			self.label=wxStaticText(self.parent,wxNewId(),label_str,size=self.wsize)
			self.label.SetLabel(`self.val['value']`)
			self.sizer.Add(self.label)

			self.defaultB.SetBackgroundColour(self.val['default'])
			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)
			
		elif self.val['wtype']=='wxSlider':
			
			self.widget=wxSlider(
				self.parent,
				wxNewId(),
				int(self.val['value']*self.val['divisor']),
				int(self.val['min']),
				int(self.val['max']),
				style=self.val['style'],
				size=self.wsize
			)
			
			
			self.sizer.Add(self.widget)

			sliderID=wxNewId()
			div=self.val['divisor']
			if div==1.:label_str="%.0f"%(self.val['value'])
			if div==10.:label_str="%.1f"%(self.val['value'])
			if div==100.:label_str="%.2f"%(self.val['value'])
			if div==1000.:label_str="%.3f"%(self.val['value'])
			if div==10000.:label_str="%.4f"%(self.val['value'])
			
			self.label=wxStaticText(self.parent,sliderID,label_str,size=self.wsize)
			self.sizer.Add(self.label)
			
			EVT_BUTTON(self.defaultB,self.defaultBID,self.defaultCB)
			EVT_SCROLL(self.widget,self.sliderCB)
		
		self.sizer.Add(self.defaultB)
		if self.val.has_key('tooltip'):
			if DEBUG:print self.val
			self.defaultB.SetToolTip(wxToolTip(self.val['tooltip']))
			
	def comboCB(self,evt):
		newval=self.widget.GetValue()
		fname=os.path.abspath(os.path.join(self.env.sitepkgdir,self.global_config['APPNAME'],'Actors',newval,'icon.gif'))
		self.bmp.SetBitmap(wxImage(fname,wxBITMAP_TYPE_GIF).ConvertToBitmap())
		
		
	def imagedialogCB(self,evt):
		if self.widget.ShowModal()==wxID_OK:
			fname=self.widget.GetFile()
			self.val['value']=str(os.path.basename(fname))
			self.label.SetLabel(self.val['value'])
			
	def filedialogCB(self,evt):
		if self.widget.ShowModal()==wxID_OK:
			path=self.widget.GetPaths()[0]
			self.val['path']=str(os.path.dirname(path))
			self.val['value']=str(os.path.basename(path))
			self.label.SetLabel(self.val['value'])
			
	def checkboxCB(self,evt):
		if self.widget.GetValue():value_str="On"
		else:value_str="Off"
		self.label.SetLabel(value_str)

	def spinctrlCB(self,evt):
		value_str="%02d"%(self.widget.GetValue())
		self.label.SetLabel(value_str)
	
	def sliderCB(self,evt):
		if DEBUG:print 'sliderCB: ',self.widget.GetValue()
		div=self.val['divisor']
		if div==1.:label_str="%.0f"%(self.widget.GetValue()/self.val['divisor'])
		if div==10.:label_str="%.1f"%(self.widget.GetValue()/self.val['divisor'])
		if div==100.:label_str="%.2f"%(self.widget.GetValue()/self.val['divisor'])
		if div==1000.:label_str="%.3f"%(self.widget.GetValue()/self.val['divisor'])
		if div==10000.:label_str="%.4f"%(self.widget.GetValue()/self.val['divisor'])
		self.label.SetLabel(label_str)
	
	def defaultCB(self,evt):
		
		#print dir(self.parent)
		self.parent.Layout()
		
		if self.val['wtype']=='wxComboBox':
			self.widget.SetValue(self.val['default'])
			self.comboCB(None)
			
		elif self.val['wtype']=='wxTextCtrl':
			self.widget.SetValue(self.val['default'])
			
		elif self.val['wtype']=='wxSlider':
			self.widget.SetValue(int(self.val['default']*self.val['divisor']))
			self.sliderCB(None)
			
		elif self.val['wtype']=='ImageDialog':
			self.val['value']=self.val['default']
			self.label.SetLabel(self.val['value'])

		elif self.val['wtype']=='wxFileDialog':
			self.val['value']=self.val['default']
			self.label.SetLabel(self.val['value'])

		elif self.val['wtype']=='wxColourDialog':
			self.val['value']=self.val['default']
			self.label.SetLabel(`self.val['value']`)
			self.widget.GetColourData().SetColour(self.val['value'])
			self.showColourDialogB.SetBackgroundColour(self.val['value'])

		elif self.val['wtype']=='wxSpinCtrl':
			self.widget.SetValue(int(self.val['default']))
			self.spinctrlCB(None)
		
		elif self.val['wtype']=='wxCheckBox':
			self.widget.SetValue(int(self.val['default']))
			self.checkboxCB(None)
	
	def showColourDialogCB(self,evt):
		if self.widget.ShowModal()==wxID_OK:pass
		else:return
		self.label.SetLabel(`self.val['value']`)		
		self.showColourDialogB.SetBackgroundColour(self.widget.GetColourData().GetColour().Get())
				
	def update(self):
		if self.val['wtype']=='wxComboBox':
			self.val['value']=str(self.widget.GetValue())
			
		elif self.val['wtype']=='wxTextCtrl':
			self.val['value']=str(self.widget.GetValue())
			
		elif self.val['wtype']=='ImageDialog':
			#self.val['value']=os.path.basename(self.widget.GetFile())
			if DEBUG:print 'value=',self.val['value'],self.label.GetLabel()
			
			"""
		elif self.val['wtype']=='wxFileDialog':
			try:
				self.val['path']=str(os.path.dirname(self.widget.GetPaths()[0]))
				self.val['value']=str(os.path.basename(self.widget.GetPaths()[0]))
				if DEBUG:print 'path=',self.val['path']#,self.label.GetLabel()
				if DEBUG:print 'value=',self.val['value']#,self.label.GetLabel()
			except Exception,e:
				print 'Line 288 cfgctrlobj.py: ',e
			"""
			
		elif self.val['wtype']=='wxSpinCtrl':
			self.val['value']=int(self.widget.GetValue())#was float
			if DEBUG:print 'value=',self.val['value'],self.label.GetLabel()

		elif self.val['wtype']=='wxCheckBox':
			self.val['value']=int(self.widget.GetValue())
			if DEBUG:print 'value=',self.val['value'],self.label.GetLabel()

		elif self.val['wtype']=='wxSlider':
			self.val['value']=float(self.widget.GetValue())/self.val['divisor']#was float
			if DEBUG:print 'value=',self.val['value'],self.label.GetLabel()

		elif self.val['wtype']=='wxColourDialog':
			#LEAVE OFF: @default need to SetColourData -- need refer to wx API...TBC.
			data=self.widget.GetColourData()
			self.val['value']=data.GetColour().Get()
			self.label.SetLabel(`self.val['value']`)
		
